routes/web.php
<?php

use App\Http\Controllers\BackendController;
use App\Http\Controllers\BookingController;
use App\Http\Controllers\BrandController;
use App\Http\Controllers\CartController;
use App\Http\Controllers\CategoryController;
use App\Http\Controllers\ColorController;
use App\Http\Controllers\CommentController;
use App\Http\Controllers\CourseController;
use App\Http\Controllers\DashboardController;
use App\Http\Controllers\DistrictController;
use App\Http\Controllers\frontend\FrontendCategoryController;
use App\Http\Controllers\frontend\FrontendProductController;
use App\Http\Controllers\FrontendController;
use App\Http\Controllers\ProductController;
use App\Http\Controllers\PublicController;
use App\Http\Controllers\RoleController;
use App\Http\Controllers\SizeController;
use App\Http\Controllers\TagController;
use App\Http\Controllers\UserController;
use App\Http\Controllers\ProfileController;
use App\Http\Controllers\SliderController;
use App\Http\Controllers\CustomerController;
use App\Http\Controllers\FaqController;
use Illuminate\Support\Facades\Route;
use Spatie\FlareClient\Api;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/



// Route::get('/dashboard', function () {
//     return view('dashboard');
// })->middleware(['auth'])->name('dashboard');

require __DIR__.'/auth.php';
Route::get('Front/index', [PublicController::class, 'index'])->name('homepage');
Route::get('Front/cart', [PublicController::class, 'cart'])->name('Cart');
Route::get('Front/checkout', [PublicController::class, 'checkout'])->name('Check');
Route::get('Front/order', [PublicController::class, 'order'])->name('order');
Route::get('Front/shop', [PublicController::class, 'shop'])->name('Shop');
Route::get('Front/checkout', [PublicController::class, 'product'])->name('Product');
Route::get('/about', [PublicController::class, 'about'])->name('About');
// Route::get('Front/index', [PublicController::class, 'index']);
// Route::get('Front/cart', [PublicController::class, 'cart'])->name('Cart');
// Route::get('Front/checkout', [PublicController::class, 'checkout'])->name('Check');
// Route::get('Front/order', [PublicController::class, 'order'])->name('order');
// Route::get('Front/shop', [PublicController::class, 'shop'])->name('Shop');
// Route::get('Front/checkout', [PublicController::class, 'product'])->name('Product');
// Route::get('/about', [PublicController::class, 'about'])->name('About');

// Route::get('/sign-in', [AuthController::class, 'login'])->name('sign_in');
// Route::get('/sign-up', [AuthController::class, 'registration'])->name('sign_up');
//route group*****************************************************
// Route::controller(ProductsController::class)->prefix('products')->group(function(){
//     Route::get('/','index')->name('pro_index');
//     Route::get('/create','create')->name('pro_create');
//     Route::get('/show','show')->name('pro_show');
// });
//middleware******************************************************
//Route::get('/admin',[DashboardController::class,'dashboard' ])->middleware('admin');
// Route::middleware('admin')->group(function(){
//     Route::get('/admin',[DashboardController::class,'dashboard' ]);
//     Route::controller(ProductsController::class)
//     ->name('products.')
//     ->prefix('products')
//     ->group(function(){
//         Route::get('/','index')->name('index');
//         // Route::get('/create','create')->name('create');
//         Route::get('/show','show')->name('show');
//     });
//     // Route::fallback(function () {
//     //     echo "Sorry";
//     // });
// });
//basic routing***************************************************
// Route::get('/', function () {
//     return view('index');
// });
// Route::get('/index', function () {
//     return "hello world";
// });
//view route*****************************
// Route::view('/', 'index');
//fallback route*************************
// Route::fallback(function () {
//     echo "Sorry";
// });

//redirect*******************************
//Route::redirect('/here', '/ounnokisu');
//require parameter*********************************************************
// Route::get('/products/{id?}', [ProductsController::class, 'show']);
// Route::get('/products/create', [ProductsController::class, 'create']);
Route::get('/', [FrontendController::class, 'index'])->name('Homepage');
Route::get('/category', [FrontendController::class,'category']);
Route::get('/components/frontend/layout/master', [FrontendController::class, 'master'])->name('frontend.master');
Route::get('/category/{category}/products', [FrontendController::class, 'categoryWiseProducts'])->name('categories.products');
Route::get('/products/{product}', [FrontendController::class, 'productDetails'])->name('frontend.product.detail');
Route::post('/products/{product}/comments', [CommentController::class, 'store'])->name('products.comments.store');
Route::get('/components/backend/layout/master', [BackendController::class, 'master'])->name('backend.master');
Route::get('/backend/index', [BackendController::class, 'index']);

// Route::get('/products/{product}/booking', [BookingController::class, 'booking'])->name('booking');

// Route::get('/products/{product}/checkout-address', [BookingController::class, 'checkoutAddress'])->name('checkout.address');
// Route::get('/products/{product}/checkout-payment', [BookingController::class, 'checkoutPayment'])->name('checkout.payment');
// Route::get('/products/{product}/checkout-review', [BookingController::class, 'checkoutReview'])->name('checkout.review');



Route::get('/faqs', [FaqController::class,'frontendshow'])->name('faqs.frontend');

Route::middleware('auth','isAdmin')->prefix('backend')->group(function () {
    Route::get('/', [BackendController::class, 'index'])->name('backend.index');
    // Route::get('/product', [ProductController::class, 'index'])->name('product.index');
    // Route::get('/product/create', [ProductController::class, 'create'])->name('product.create');
    
    // Route::get('/colors', [ColorController::class, 'index'])->name('colors.index');
    // Route::get('/colors/create', [ColorController::class, 'create'])->name('colors.create');
    // Route::post('/colors', [ColorController::class, 'store'])->name('colors.store');
    // Route::get('/colors/{color}', [ColorController::class, 'show'])->name('colors.show');
    // Route::get('/colors/{color}/edit', [ColorController::class, 'edit'])->name('colors.edit');
    // Route::patch('/colors/{color}/edit', [ColorController::class, 'update'])->name('colors.update');
    // Route::delete('/colors/{color}', [ColorController::class, 'destroy'])->name('colors.destroy');
    Route::get('/products/trash', [ProductController::class, 'trash'])->name('products.trash');
    Route::patch('/products/trash/{id}', [ProductController::class, 'restore'])->name('products.restore');
    Route::delete('/products/trash/{id}', [ProductController::class, 'delete'])->name('products.delete');
   
    Route::get('/products/list/{category}', [CategoryController::class, 'productlist'])->name('products.list');
    Route::get('/categories/trash', [CategoryController::class, 'trash'])->name('categories.trash');
    Route::patch('/categories/trash/{id}', [CategoryController::class, 'restore'])->name('categories.restore');
    Route::delete('/categories/trash/{id}', [CategoryController::class, 'delete'])->name('categories.delete');
    Route::get('categories/download-pdf', [CategoryController::class, 'downloadPdf'])->name('categories.download_pdf');
    Route::get('categories/download-excel', [CategoryController::class, 'downloadExcel'])->name('categories.download_excel');
    
    Route::get('/courses/trash', [CourseController::class, 'trash'])->name('courses.trash');
    Route::get('courses/download-pdf', [CourseController::class, 'downloadPdf'])->name('courses.download_pdf');
    Route::get('courses/download-excel', [CourseController::class, 'downloadExcel'])->name('courses.download_excel');
    Route::resource('courses', CourseController::class);
    Route::resource('colors', ColorController::class);
    Route::resource('categories', CategoryController::class);
    Route::resource('sizes', SizeController::class);
    Route::resource('tags', TagController::class);
    Route::resource('districts', DistrictController::class); 
    Route::resource('brands', BrandController::class);
    Route::resource('products', ProductController::class);
    Route::resource('users', UserController::class);
    Route::resource('roles', RoleController::class);
    Route::resource('faqs', FaqController::class);
    
    
     // ===============Slider==============

     Route::get('/sliders/trash', [SliderController::class, 'trash'])->name('sliders.trash');     
     Route::patch('/sliders/trash/{id}', [SliderController::class, 'restore'])->name('sliders.restore');
     Route::delete('/sliders/trash/{id}', [SliderController::class, 'delete'])->name('sliders.delete');

     Route::resource('sliders', SliderController::class);


    
});

Route::prefix('frontend')->group(function () {
    
});



Route::middleware('auth','isUser')->group(function () {
    Route::get('booking-list/{user}',  [CustomerController::class, 'booking'])->name('customer.bookingList');
    Route::get('wishlist/{user}',  [CustomerController::class, 'wishlist'])->name('customer.wishlist');
    Route::get('/my-account/{user}',  [CustomerController::class, 'account'])->name('customer.account');
});


Route::middleware(['auth'])->group(function () {
    // Route::get('account/{user}',  [ProfileController::class, 'account'])->name('customer.profile');

app/Http/Controllers/BackendController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;

class BackendController extends Controller
{
    public function master(){
        return view('components.backend.layout.master');
    }
    public function index(){
        return view('backend.index');
    }
}

resources/views/backend/courses/create.blade.php
<x-backend.layout.master>
    <x-slot:title>
        courses
        </x-slot:>
        <x-slot:pagetitle>
            courses
            </x-slot:>
            <div class="card mb-4">
                <div class="card-header">
                    <i class="fas fa-table me-1"></i>
                    course Create
                    <a href="{{ route('courses.index') }}" class="btn btn-sm btn-primary">List</a>
                </div>
                <div class="card-body">
                    @if ($errors->any())
                        <x-backend.alerts.errors />
                    @endif

                    <form method="POST" action="{{ route('courses.store') }}" enctype="multipart/form-data">
                        @csrf

                        <x-backend.forms.input name="title" type="text" :value="old('title')" />

                        @error('title')
                            <div class="form-text text-danger">{{ $message }}</div>
                        @enderror
                        <x-backend.forms.input name="batch_no" :value="old('batch_no')" />

                        @error('batch_no')
                            <div class="form-text text-danger">{{ $message }}</div>
                        @enderror
                        <x-backend.forms.input type="date" name="class_start_date" :value="old('class_start_date')" />

                        @error('class_start_date')
                            <div class="form-text text-danger">{{ $message }}</div>
                        @enderror

                        <x-backend.forms.input type="date" name="class_end_date" :value="old('class_end_date')" />

                        @error('class_end_date')
                            <div class="form-text text-danger">{{ $message }}</div>
                        @enderror
                        <x-backend.forms.input type="text" name="instructor_name" :value="old('instructor_name')" />

                        @error('instructor_name')
                            <div class="form-text text-danger">{{ $message }}</div>
                        @enderror
                        <x-backend.forms.input name="baner" type="file" />


                        <div class="mb-3 form-check">
                            <input type="checkbox" value="1" name="is_active" class="form-check-input"
                                id="isactiveinput">
                            <label class="form-check-label" for="isactiveinput">Is Active</label>
                        </div>
                        <div class="mb-3 form-check">
                            <label class="form-slect-label" >Course Tyoe</label>
                            <select name="course_type" >
                                <option value="virtual">Virtual</option>
                                <option value="physical">Physical</option>
                              </select>
                        </div>
                        

                  
                        <button type="submit" class="btn btn-primary">Create</button>
                    </form>
                </div>
            </div>

            @push('css')
                <style>
                    /* body{
                        background-color: blue;
                    } */
                </style>
            @endpush
            @push('js')
                <script src="https://cdn.jsdelivr.net/npm/simple-datatables@latest" crossorigin="anonymous"></script>
                <script src="{{ asset('ui/backend/js/datatables-simple-demo.js') }}"></script>
            @endpush
</x-backend.layout.master>

resources/views/backend/courses/edit.blade.php
<x-backend.layout.master>
    <x-slot:title>
        courses
        </x-slot:>
        <x-slot:pagetitle>
            courses
            </x-slot:>
            <div class="card mb-4">
                <div class="card-header">
                    <i class="fas fa-table me-1"></i>
                    course Edit
                    <a href="{{route('courses.index')}}" class="btn btn-sm btn-primary">List</a>
                </div>
                <div class="card-body">
                          @if($errors->any())
                            <div class="alert alert-danger">
                                <ul>
                                    @foreach($errors->all() as $error)
                                    <li>{{$error}}</li>
                                    @endforeach
                                </ul>
                            </div>
                          @endif
                   
                    <form method="POST" action="{{route('courses.update',['course'=>$course->id])}}">
                        @csrf
                        @method ('patch')
                      

                        <div class="mb-3">
                            <label  class="form-label">course Name</label>
                            <input name="title" type="text" value="{{old('title',$course->title)}}" class="form-control @error('title')is-invalid @enderror" >
                          
                            @error('title')
                            <div class="form-text text-danger">{{$message}}</div>
                            @enderror
                         
                        </div>
                        <div class="mb-3">
                            <label  class="form-label">Batch No</label>
                            <input name="batch_no" type="text" value="{{old('batch_no',$course->batch_no)}}" class="form-control @error('batch_no')is-invalid @enderror" >
                          
                            @error('batch_no')
                            <div class="form-text text-danger">{{$message}}</div>
                            @enderror
                         
                        </div>
                        <div class="mb-3">
                            <label  class="form-label">class start date</label>
                            <input name="class_start_date" type="text" value="{{old('class_start_date',$course->class_start_date)}}" class="form-control @error('class_start_date')is-invalid @enderror" >
                          
                            @error('class_start_date')
                            <div class="form-text text-danger">{{$message}}</div>
                            @enderror
                         
                        </div>
                        
                        <div class="mb-3">
                            <label  class="form-label">class_end_date</label>
                            <input name="class_end_date" type="text" value="{{old('class_end_date',$course->class_end_date)}}" class="form-control @error('class_end_date')is-invalid @enderror" >
                          
                            @error('class_end_date')
                            <div class="form-text text-danger">{{$message}}</div>
                            @enderror
                         
                        </div>
                        <div class="mb-3">
                            <label  class="form-label">Instructor Name</label>
                            <input name="instructor_name" type="text" value="{{old('instructor_name',$course->instructor_name)}}" class="form-control @error('instructor_name')is-invalid @enderror" >
                          
                            @error('instructor_name')
                            <div class="form-text text-danger">{{$message}}</div>
                            @enderror
                         
                        </div>
                        <img src="{{ asset('storage/courses/'.$course->baner) }}" alt="{{$course->baner}} Image" height="200">
                        <x-backend.forms.input name="baner" type="file"/>
                      
                        <div class="mb-3 form-check">
                            <input type="checkbox" value="1" name="is_active" class="form-check-input"
                                id="isactiveinput" {{ $course->is_active ? 'checked' : ''}}>
                            <label class="form-check-label" for="isactiveinput">Is Active</label>
                        </div>

                        <div class="mb-3 form-check">
                            <label class="form-slect-label" >Course Tyoe</label>
                            <select name="course_type" >
                                <option value="virtual">Virtual</option>
                                <option value="physical">Physical</option>
                              </select>
                        </div>
                        
                        <button type="submit" class="btn btn-primary">Update</button>
                    </form>
                </div>
            </div>

            @push('css')
            <style>
            /* body{
                background-color: blue;
            } */
            </style>
            @endpush
            @push('js')
            <script src="https://cdn.jsdelivr.net/npm/simple-datatables@latest" crossorigin="anonymous"></script>
            <script src="{{asset('ui/backend/js/datatables-simple-demo.js')}}"></script>
            @endpush
</x-backend.layout.master>

resources/views/backend/courses/index.blade.php
<x-backend.layout.master>
    <x-slot:title>
        Courses
        </x-slot:>
        <x-slot:pagetitle>
            Courses
            </x-slot:>
            <div class="card mb-4">

                <div class="card-header">
                    <i class="fas fa-table me-1"></i>
                    Course List
                    <a href="{{ route('courses.create') }}" class="btn btn-sm btn-primary">Add New</a>
                    <a class="btn btn-sm btn-info" href="{{ route('courses.trash') }}">Trash</a>
                    <a class="btn btn-sm btn-info" href="{{ route('courses.download_pdf') }}">Pdf</a>
                    <a class="btn btn-sm btn-info" href="{{ route('courses.download_excel') }}">Excel</a>
                </div>
                <div class="card-body">
                    <x-backend.alerts.message type="success" :message="session('message')" class="text-dark" />
                    <table id="datatablesSimple">
                        <thead>
                            <tr>
                                <th>#</th>
                                <th>Course Name</th>
                                <th>Batch_No</th>
                                <th>Class Start Date</th>
                                <th>Class End Date</th>
                                <th>Instructor Name</th>
                                <th>Baner</th>
                                <th>Is active</th>
                                <th>Course type</th>

                                <th>Action</th>


                            </tr>
                        </thead>

                        <tbody>


                            @foreach ($courses as $course)
                                <tr>
                                    <td>{{ $loop->iteration }} </td>
                                    <td>{{ $course->title }}</td>
                                    <td>{{ $course->batch_no }}</td>
                                    <td>{{ $course->class_start_date }}</td>
                                    <td>{{ $course->class_end_date }}</td>
                                    <td>{{ $course->instructor_name }}</td>
                                    <td>{{ $course->baner }}</td>
                                    <td>{{ $course->is_active }}</td>
                                    <td>{{ $course->course_type }}</td>



                                    <td >
                                        <x-backend.utilities.link-show
                                            href="{{ route('courses.show', ['course' => $course->id]) }}"
                                            icon="fas fa-eye" />
                                        <x-backend.utilities.link-edit
                                            href="{{ route('courses.edit', ['course' => $course->id]) }}"
                                            icon="fas fa-edit" />

                                        <form action="{{ route('courses.destroy', ['course' => $course->id]) }}"
                                            method="post" style="display:inline">
                                            @csrf
                                            @method('delete')
                                            <x-backend.forms.button text='Delete' color='danger' icon='fas fa-trash'
                                                onclick="return confirm('Are you sure want to delete?')" />
                                        </form>

                                    </td>

                                </tr>
                            @endforeach
                        </tbody>
                    </table>
                </div>
            </div>

            @push('css')
                <style>
                    /* body{
                    background-color: blue;
                } */
                </style>
            @endpush
            @push('js')
                <script src="https://cdn.jsdelivr.net/npm/simple-datatables@latest" crossorigin="anonymous"></script>
                <script src="{{ asset('ui/backend/js/datatables-simple-demo.js') }}"></script>
            @endpush
</x-backend.layout.master>

resources/views/backend/courses/pdf.blade.php
<table border="1" style="width: 100%;">
    <thead>
        <tr>
            <td>Title</td>
            <td>Description</td>
        </tr>
    </thead>

    <tbody>
        @foreach ($categories as $category)
        <tr>
            <td>{{ $category->title }}</td>
            <td>{{ $category->description }}</td>
        </tr>    
        @endforeach
        
    </tbody>
</table>

resources/views/backend/courses/show.blade.php
<x-backend.layout.master>
    <x-slot:title>
        Courses
        </x-slot:>
        <x-slot:pagetitle>
            Courses
            </x-slot:>
            <div class="card mb-4">

                <div class="card-header">
                    <i class="fas fa-table me-1"></i>
                    course Details
                    <a href="{{ route('courses.create') }}" class="btn btn-sm btn-primary">Add New</a>
                </div>
                <div class="card-body">
                    @if (session('massage'))
                        <div class="alert alert-success" role="alert">
                            {{ session('massage') }}

                        </div>
                    @endif
                    <table id="datatablesSimple">
                        <thead>
                     
                            <tr>
                                <th>Course Name</th>
                                <th>{{ $course->title}}</th>
                            </tr>
                            <tr>
                                <th>Batch No</th>
                                <th>{{ $course->batch_no }}</th>
                            </tr>
                            <tr>
                                <th>Class start date</th>
                                <th>{{ $course->class_start_date}}</th>
                            </tr>
                            <tr>
                                <th>Class end date</th>
                                <th>{{ $course->class_end_date}}</th>
                            </tr>
                            <tr>
                                <th>Instructor Name</th>
                                <th>{{$course->instructor_name}}</th>
                            </tr>
                            <tr>
                                <th>Baner</th>
                                <th><img src="{{ asset('storage/courses/'.$course->baner) }}" alt="{{$course->title}} Image" height="200"></th>
                            </tr>
                           
                            <tr>
                                <th>Is active</th>
                                <th>{{ $course->is_active }}</th>
                            </tr>
                            <tr>
                                <th>Course Type</th>
                                <th>{{ $course->course_type }}</th>
                            </tr>

                            <tr>

                                <th>created_at</th>
                                <th>{{ $course->created_at }}</th>
                            </tr>
                            <tr>

                                <th>updated_at</th>
                                <th>{{ $course->updated_at }}</th>
                            </tr>
                            <tr>

                                <th>deleted_at</th>
                                <th>{{ $course->updated_at }}</th>
                            </tr>
                        </thead>


                    </table>
                </div>
            </div>

            @push('css')
                <style>
                    /* body{
                        background-color: blue;
                    } */
                </style>
            @endpush
            @push('js')
                <script src="https://cdn.jsdelivr.net/npm/simple-datatables@latest" crossorigin="anonymous"></script>
                <script src="{{ asset('ui/backend/js/datatables-simple-demo.js') }}"></script>
            @endpush
</x-backend.layout.master>

resources/views/backend/courses/trash.blade.php
<x-backend.layout.master>
    <x-slot:title>
        Categories
    </x-slot:title>

    <x-slot:pagetitle>
        Categories
    </x-slot:pagetitle>

    <div class="card mb-4">
        <div class="card-header">
            <i class="fas fa-table me-1"></i>
            Category Trash List
            <a class="btn btn-sm btn-primary" href="{{route('categories.index') }}">List</a>
        </div>
        <div class="card-body">

            @if ($errors->any())
                <x-backend.alerts.errors />
            @endif
            
            <x-backend.alerts.message type="success" :message="session('message')" />

            <table class="table">
                <thead>
                    <tr>
                        <th>SL#</th>
                        <th>Title</th>
                        <th>Is Active ?</th>
                        <th>Action</th>
                    </tr>
                </thead>
                <tbody>
                    @foreach($categories as $category)
                    <tr>
                        <td>{{ $loop->iteration }}</td>
                        <td>{{ $category->categories_name }}</td>
                        <td>{{ $category->is_active ? 'Active' : 'In Active' }}</td>
                        <td>
                                        
                            <form method="post" action="{{ route('categories.restore', ['id' => $category->id]) }}" style="display:inline">
                                @method('patch')
                                @csrf
                               
                                <x-backend.forms.button color="warning" onclick="return confirm('Are you sure want to restore?')" text="Restore" icon=""/>
                            </form>


                            <form method="post" action="{{ route('categories.delete', ['id' => $category->id]) }}" style="display:inline">
                                @csrf
                                @method('delete')
                                <x-backend.forms.button color="danger" onclick="return confirm('Are you sure want to delete permanently?')" text="Delete" icon="fas fa-trash" />
                            </form>


                        </td>
                    </tr>
                    @endforeach
                </tbody>
            </table>

            {{ $categories->links() }}

        </div>
    </div>

    {{-- page specific css --}}
    @push('css')

    @endpush

    {{-- page specific js --}}
    @push('js')
    <script src="https://cdn.jsdelivr.net/npm/simple-datatables@latest" crossorigin="anonymous"></script>
    <script src="{{ asset('ui/backend') }}/js/datatables-simple-demo.js"></script>
    @endpush

</x-backend.layout.master>